#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>

extern int errno;

int nextup(int multiple, int checking) {
	return ((checking / multiple) * multiple) + multiple;
}

//please, PLEASE free() this!

char *readfile(const char *filename) {
	int fd = open(filename, O_RDONLY);
	if (fd == -1) {
		perror("read");
		return (char *) -1;
	}
	struct stat fileinfo;
	if (fstat(fd, &fileinfo)) {
		perror("fstat");
		return (char *) -1;
	}
	ssize_t ret;
	//this next line makes sure that you try to read in multiples of the blocksize. Helllllo optimization :D
	int readlen = nextup(fileinfo.st_blksize, fileinfo.st_size); //st_blocks is very, very wrong. don't use it.
	int len = fileinfo.st_size;
	int oldlen = len;
	char *buf = malloc(len);
	if (!buf) {
		perror("malloc");
		return (char *) -1;
	}
	char *oldbuf = buf;
	
	//people who make short reads are bad programmers.
	while (len != 0 && (ret = read(fd, buf, readlen)) != 0) {
		if (ret == -1) {
			if (errno == EINTR)
				continue;
			perror ("read");
			break;
		}
		
		len -= ret;
		buf += ret;
	}
	buf = oldbuf; //I didn't have this before - couldn't figure out why free segfaulted *facepalm*
	len = oldlen;
	if (close(fd))
		return (char *) -1;
	//done with file I/O... buf now contains the file.
	return buf;
}
